<?xml version="1.0" encoding="UTF-8" ?>

<!--
    Document   : dumpaxes.xsl
    Created on : January 21, 2004, 7:35 PM
    Author     : alex
    Description:
        Purpose of transformation follows.
-->

<xsl:transform version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
   xmlns="http://www.w3.org/1999/xhtml"
>

    <xsl:template name="dump-axes">
       <div class="axes-dump">

       <!-- child axis -->
       <div class="axis">
          <p class="axis">
            <span class="axis-label">child:: </span>
            <xsl:for-each select="child::node()">
            <xsl:call-template name="dump-node">
            <xsl:with-param name="type">element</xsl:with-param>
            </xsl:call-template>
            </xsl:for-each>
          </p>
       </div>
       
       <!-- descendant axis -->
       <div class="axis">
          <p class="axis">
            <span class="axis-label">descendant:: </span>
            <xsl:for-each select="descendant::node()">
            <xsl:call-template name="dump-node">
            <xsl:with-param name="type">element</xsl:with-param>
            </xsl:call-template>
            </xsl:for-each>
          </p>
       </div>
       
       <!-- parent axis -->
       <div class="axis">
          <p class="axis">
            <span class="axis-label">parent:: </span>
            <xsl:for-each select="parent::node()">
            <xsl:call-template name="dump-node">
            <xsl:with-param name="type">element</xsl:with-param>
            </xsl:call-template>
            </xsl:for-each>
          </p>
       </div>
       
       <!-- ancestor axis -->
       <div class="axis">
          <p class="axis">
            <span class="axis-label">ancestor:: </span>
            <xsl:for-each select="ancestor::node()">
            <xsl:call-template name="dump-node">
            <xsl:with-param name="type">element</xsl:with-param>
            </xsl:call-template>
            </xsl:for-each>
          </p>
       </div>
       
       <!-- following-sibling axis -->
       <div class="axis">
          <p class="axis">
            <span class="axis-label">following-sibling:: </span>
            <xsl:for-each select="following-sibling::node()">
            <xsl:call-template name="dump-node">
            <xsl:with-param name="type">element</xsl:with-param>
            </xsl:call-template>
            </xsl:for-each>
          </p>
       </div>
       
       <!-- preceding-sibling axis -->
       <div class="axis">
          <p class="axis">
            <span class="axis-label">preceding-sibling:: </span>
            <xsl:for-each select="preceding-sibling::node()">
            <xsl:call-template name="dump-node">
            <xsl:with-param name="type">element</xsl:with-param>
            </xsl:call-template>
            </xsl:for-each>
          </p>
       </div>
       
       <!-- following axis -->
       <div class="axis">
          <p class="axis">
            <span class="axis-label">following:: </span>
            <xsl:for-each select="following::node()">
            <xsl:call-template name="dump-node">
            <xsl:with-param name="type">element</xsl:with-param>
            </xsl:call-template>
            </xsl:for-each>
          </p>
       </div>
       
       <!-- preceding axis -->
       <div class="axis">
          <p class="axis">
            <span class="axis-label">preceding:: </span>
            <xsl:for-each select="preceding::node()">
            <xsl:call-template name="dump-node">
            <xsl:with-param name="type">element</xsl:with-param>
            </xsl:call-template>
            </xsl:for-each>
          </p>
       </div>
       
       <!-- attribute axis -->
       <div class="axis">
          <p class="axis">
            <span class="axis-label">attribute:: </span>
            <xsl:for-each select="attribute::node()">
            <xsl:call-template name="dump-node">
            <xsl:with-param name="type">attribute</xsl:with-param>
            </xsl:call-template>
            </xsl:for-each>
          </p>
       </div>
       
       <!-- namespace axis -->
       <div class="axis">
          <p class="axis">
            <span class="axis-label">namespace:: </span>
            <xsl:for-each select="namespace::node()">
            <xsl:call-template name="dump-node">
            <xsl:with-param name="type">namespace</xsl:with-param>
            </xsl:call-template>
            </xsl:for-each>
          </p>
       </div>
       
       <!-- self axis -->
       <div class="axis">
          <p class="axis">
            <span class="axis-label">self:: </span>
            <xsl:for-each select="self::node()">
            <xsl:call-template name="dump-node">
            <xsl:with-param name="type">element</xsl:with-param>
            </xsl:call-template>
            </xsl:for-each>
          </p>
       </div>
       
       <!-- descendant-or-self axis -->
       <div class="axis">
          <p class="axis">
            <span class="axis-label">descendant-or-self:: </span>
            <xsl:for-each select="descendant-or-self::node()">
            <xsl:call-template name="dump-node">
            <xsl:with-param name="type">element</xsl:with-param>
            </xsl:call-template>
            </xsl:for-each>
          </p>
       </div>
       
       <!-- ancestor-or-self axis -->
       <div class="axis">
          <p class="axis">
            <span class="axis-label">ancestor-or-self:: </span>
            <xsl:for-each select="ancestor-or-self::node()">
            <xsl:call-template name="dump-node">
            <xsl:with-param name="type">element</xsl:with-param>
            </xsl:call-template>
            </xsl:for-each>
          </p>
       </div>
       
       </div>
    </xsl:template>
    
    <xsl:template name="dump-node">
    <xsl:param name="type"/>
    <xsl:choose>
    <xsl:when test="$type='element'">
       <xsl:choose>
       <xsl:when test="self::*"><span class="node"><xsl:value-of select="name(.)"/></span></xsl:when>
       <xsl:when test="self::processing-instruction()"><span class="node">&lt;?pi?></span></xsl:when>
       <xsl:when test="self::comment()"><span class="node">&lt;!-- --></span></xsl:when>
       <xsl:when test="self::text()"><span class="node">'<xsl:value-of select="."/>'</span></xsl:when>
       <xsl:otherwise>/</xsl:otherwise>
       </xsl:choose>
    </xsl:when>
    <xsl:when test="$type='attribute'">
       <span class="node">@<xsl:value-of select="name(.)"/>='<xsl:value-of select="."/>'</span>
    </xsl:when>
    <xsl:when test="$type='namespace'">
       <span class="node"><xsl:value-of select="name(.)"/>=<xsl:value-of select="."/></span>
    </xsl:when>
    </xsl:choose>
    </xsl:template>

</xsl:transform> 
