<?xml version="1.0" encoding="UTF-8" ?>

<xsl:transform version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
   xmlns="http://www.w3.org/1999/xhtml"
>

   <xsl:import href="dump-axes.xsl"/>

<!--#########################################################################-->   
<!--  ONLY MAKE YOUR CHANGES BETWEEN THIS HASH-MARK COMMENTS!!!              -->
<!--#########################################################################-->   

   <xsl:template name="top">
   <p>Create an XSLT file with the following template:</p>
   <pre>
   <![CDATA[
   
   <xsl:template name="top" >
      <!-- Change the value of the select attribute below to have your
           XPath and run this stylesheet on your document.-->
      <xsl:for-each select="your-xpath-here">
         <xsl:call-template name="dump-everything"/>
      </xsl:for-each>
   </xsl:template>
   ]]>
   </pre>
   <p><b>Don't forget to declare your namespace prefixes!</b></p>
   </xsl:template>

<!--#########################################################################-->   
<!-- DANGER, WILL ROBINSON!  GO NO FURTHER!                                  -->
<!--#########################################################################-->   

<xsl:template name="style">
       <style type="text/css">

       div.dump {
          padding: 3pt;
          border: 1pt solid gray;
       }
       p.node-type:before {
          font-weight: bold;
          content: "Node Type: ";
       }
       p.name:before {
          font-weight: bold;
          content: "Name: ";
       }
       p.local-name:before {
          font-weight: bold;
          content: "Local Name: ";
       }
       p.namespace-name:before {
          font-weight: bold;
          content: "Namespace Name: ";
       }
       p.position:before {
          font-weight: bold;
          content: "Position: ";
       }
       p.value-of:before {
          font-weight: bold;
          content: "Value: ";
       }
       div.axis {
          padding: 5pt;
       }
       p.axis {
          line-height: 210%;
       }
       span.axis-label {
          font-weight: bold;
       }
       span.node {
          border: 1pt solid gray;
          padding: 5pt;
          padding-top: 2pt;
          padding-bottom: 2pt;
          margin-bottom: 2pt;
          margin-left: 2pt;          
       }
       
       </style>
</xsl:template>

   <xsl:template match="/">
      <html>
      <head>
       <title>Context</title>
       <xsl:call-template name="style"/>
      </head>
      <body>
         <xsl:call-template name="top"/>
      </body>
      </html>
    </xsl:template>
    
    <xsl:template name="dump-everything">
    <xsl:param name="type"/>
    <div class="dump">
    <xsl:if test="self::*">
    <xsl:attribute name="id"><xsl:value-of select="name(.)"/>_<xsl:value-of select="position()"/></xsl:attribute>
    </xsl:if>
    <p class="node-type">
    <xsl:choose>
    <xsl:when test="$type"><xsl:value-of select="$type"/></xsl:when>
    <xsl:when test="self::*">element</xsl:when>
    <xsl:when test="self::text()">text</xsl:when>
    <xsl:when test="self::processing-instruction()">processing instruction</xsl:when>
    <xsl:when test="self::comment()">comment</xsl:when>
    <xsl:otherwise>attribute</xsl:otherwise>
    </xsl:choose>
    </p>
    <p class="name"><xsl:value-of select="name(.)"/></p>
    <p class="local-name"><xsl:value-of select="local-name(.)"/></p>
    <p class="namespace-name"><xsl:value-of select="namespace-uri(.)"/></p>
    <p class="position"><xsl:value-of select="position()"/></p>
    <p class="value-of">"<xsl:value-of select="."/>"</p>
    <xsl:call-template name="dump-axes"/>
    </div>
    </xsl:template>

</xsl:transform> 
